diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/timer-impl.h ns-3.42/src/core/model/timer-impl.h
--- ns-3.41/src/core/model/timer-impl.h	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/timer-impl.h	2024-05-29 15:29:46.936073000 -0700
@@ -130,946 +70,114 @@
     virtual void Invoke() = 0;
 };
 
-} // namespace ns3
-
 /********************************************************************
  *  Implementation of TimerImpl implementation functions.
  ********************************************************************/
 
-namespace ns3
-{
-
 /**
  * \ingroup timer
  * \defgroup timerimpl TimerImpl Implementation
  * @{
  */
-
-/** TimerImpl specialization class for varying numbers of arguments. */
-template <typename T1>
-struct TimerImplOne : public TimerImpl
-{
-    /**
-     * Bind the arguments to be used when the callback function is invoked.
-     *
-     * \param [in] a1 The first argument.
-     */
-    virtual void SetArguments(T1 a1) = 0;
-};
-
-/** TimerImpl specialization class for varying numbers of arguments. */
-template <typename T1, typename T2>
-struct TimerImplTwo : public TimerImpl
-{
-    /**
-     * Bind the arguments to be used when the callback function is invoked.
-     *
-     * \param [in] a1 The first argument.
-     * \param [in] a2 The second argument.
-     */
-    virtual void SetArguments(T1 a1, T2 a2) = 0;
-};
-
-/** TimerImpl specialization class for varying numbers of arguments. */
-template <typename T1, typename T2, typename T3>
-struct TimerImplThree : public TimerImpl
-{
-    /**
-     * Bind the arguments to be used when the callback function is invoked.
-     *
-     * \param [in] a1 The first argument.
-     * \param [in] a2 The second argument.
-     * \param [in] a3 The third argument.
-     */
-    virtual void SetArguments(T1 a1, T2 a2, T3 a3) = 0;
-};
-
-/** TimerImpl specialization class for varying numbers of arguments. */
-template <typename T1, typename T2, typename T3, typename T4>
-struct TimerImplFour : public TimerImpl
-{
-    /**
-     * Bind the arguments to be used when the callback function is invoked.
-     *
-     * \param [in] a1 The first argument.
-     * \param [in] a2 The second argument.
-     * \param [in] a3 The third argument.
-     * \param [in] a4 The fourth argument.
-     */
-    virtual void SetArguments(T1 a1, T2 a2, T3 a3, T4 a4) = 0;
-};
-
 /** TimerImpl specialization class for varying numbers of arguments. */
-template <typename T1, typename T2, typename T3, typename T4, typename T5>
-struct TimerImplFive : public TimerImpl
+template <typename... Args>
+struct TimerImplX : public TimerImpl
 {
     /**
      * Bind the arguments to be used when the callback function is invoked.
      *
-     * \param [in] a1 The first argument.
-     * \param [in] a2 The second argument.
-     * \param [in] a3 The third argument.
-     * \param [in] a4 The fourth argument.
-     * \param [in] a5 The fifth argument.
+     * \param [in] args The arguments to pass to the invoked method.
      */
-    virtual void SetArguments(T1 a1, T2 a2, T3 a3, T4 a4, T5 a5) = 0;
-};
-
-/** TimerImpl specialization class for varying numbers of arguments. */
-template <typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-struct TimerImplSix : public TimerImpl
-{
-    /**
-     * Bind the arguments to be used when the callback function is invoked.
-     *
-     * \param [in] a1 The first argument.
-     * \param [in] a2 The second argument.
-     * \param [in] a3 The third argument.
-     * \param [in] a4 The fourth argument.
-     * \param [in] a5 The fifth argument.
-     * \param [in] a6 The sixth argument.
-     */
-    virtual void SetArguments(T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6) = 0;
-};
-
-/** Type and reference traits for TimerImpl arguments. */
-template <typename T>
-struct TimerTraits
-{
-    /** Storage type for an argument. */
-    typedef typename TypeTraits<typename TypeTraits<T>::ReferencedType>::NonConstType StoredType;
-    /** Parameter type for an argument. */
-    typedef const StoredType& ParameterType;
+    virtual void SetArguments(Args... args) = 0;
 };
 
 /**
  * Make a TimerImpl from a function pointer taking varying numbers of arguments.
  *
- * \tparam FN \deduced Function signature type of the callback function.
- * \param [in] fn The function pointer to invoke when the timer expires.
+ * \tparam U \deduced Return type of the callback function.
+ * \tparam Ts \deduced Argument types of the callback function.
  * \returns The TimerImpl.
  */
-template <typename FN>
+template <typename U, typename... Ts>
 TimerImpl*
-MakeTimerImpl(FN fn)
+MakeTimerImpl(U(fn)(Ts...))
 {
-    NS_ASSERT(TypeTraits<FN>::IsFunctionPointer);
-    return MakeTimerImpl(IntToType<TypeTraits<FN>::FunctionPointerTraits::nArgs>(), fn);
-}
-
-/**
- * Make a TimerImpl from a function pointer taking zero arguments.
- * \copydetails MakeTimerImpl(FN)
- */
-template <typename FN>
-TimerImpl*
-MakeTimerImpl(IntToType<0>, FN fn)
-{
-    struct FnTimerImplZero : public TimerImpl
+    struct FnTimerImpl : public TimerImplX<const std::remove_cvref_t<Ts>&...>
     {
-        FnTimerImplZero(FN fn)
+        FnTimerImpl(void (*fn)(Ts...))
             : m_fn(fn)
         {
         }
 
-        EventId Schedule(const Time& delay) override
+        void SetArguments(const std::remove_cvref_t<Ts>&... args) override
         {
-            return Simulator::Schedule(delay, m_fn);
-        }
-
-        void Invoke() override
-        {
-            m_fn();
-        }
-
-        FN m_fn;
-    }* function = new FnTimerImplZero(fn);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking one argument.
- * \copydetails MakeTimerImpl(FN)
- */
-template <typename FN>
-TimerImpl*
-MakeTimerImpl(IntToType<1>, FN fn)
-{
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-
-    struct FnTimerImplOne : public TimerImplOne<T1Parameter>
-    {
-        FnTimerImplOne(FN fn)
-            : m_fn(fn)
-        {
-        }
-
-        void SetArguments(T1Parameter a1) override
-        {
-            m_a1 = a1;
+            m_arguments = std::tuple(args...);
         }
 
         EventId Schedule(const Time& delay) override
         {
-            return Simulator::Schedule(delay, m_fn, m_a1);
+            return std::apply(
+                [&, this](Ts... args) { return Simulator::Schedule(delay, m_fn, args...); },
+                m_arguments);
         }
 
         void Invoke() override
         {
-            m_fn(m_a1);
-        }
-
-        FN m_fn;
-        T1Stored m_a1;
-    }* function = new FnTimerImplOne(fn);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking two arguments.
- * \copydetails MakeTimerImpl(FN)
- */
-template <typename FN>
-TimerImpl*
-MakeTimerImpl(IntToType<2>, FN fn)
-{
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg2Type T2;
-    typedef typename TimerTraits<T2>::ParameterType T2Parameter;
-    typedef typename TimerTraits<T2>::StoredType T2Stored;
-
-    struct FnTimerImplTwo : public TimerImplTwo<T1Parameter, T2Parameter>
-    {
-        FnTimerImplTwo(FN fn)
-            : m_fn(fn)
-        {
-        }
-
-        void SetArguments(T1Parameter a1, T2Parameter a2) override
-        {
-            m_a1 = a1;
-            m_a2 = a2;
-        }
-
-        EventId Schedule(const Time& delay) override
-        {
-            return Simulator::Schedule(delay, m_fn, m_a1, m_a2);
-        }
-
-        void Invoke() override
-        {
-            m_fn(m_a1, m_a2);
-        }
-
-        FN m_fn;
-        T1Stored m_a1;
-        T2Stored m_a2;
-    }* function = new FnTimerImplTwo(fn);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking three arguments.
- * \copydetails MakeTimerImpl(FN)
- */
-template <typename FN>
-TimerImpl*
-MakeTimerImpl(IntToType<3>, FN fn)
-{
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg2Type T2;
-    typedef typename TimerTraits<T2>::ParameterType T2Parameter;
-    typedef typename TimerTraits<T2>::StoredType T2Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg3Type T3;
-    typedef typename TimerTraits<T3>::ParameterType T3Parameter;
-    typedef typename TimerTraits<T3>::StoredType T3Stored;
-
-    struct FnTimerImplThree : public TimerImplThree<T1Parameter, T2Parameter, T3Parameter>
-    {
-        FnTimerImplThree(FN fn)
-            : m_fn(fn)
-        {
-        }
-
-        void SetArguments(T1Parameter a1, T2Parameter a2, T3Parameter a3) override
-        {
-            m_a1 = a1;
-            m_a2 = a2;
-            m_a3 = a3;
-        }
-
-        EventId Schedule(const Time& delay) override
-        {
-            return Simulator::Schedule(delay, m_fn, m_a1, m_a2, m_a3);
-        }
-
-        void Invoke() override
-        {
-            m_fn(m_a1, m_a2, m_a3);
-        }
-
-        FN m_fn;
-        T1Stored m_a1;
-        T2Stored m_a2;
-        T3Stored m_a3;
-    }* function = new FnTimerImplThree(fn);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking four arguments.
- * \copydetails MakeTimerImpl(FN)
- */
-template <typename FN>
-TimerImpl*
-MakeTimerImpl(IntToType<4>, FN fn)
-{
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg2Type T2;
-    typedef typename TimerTraits<T2>::ParameterType T2Parameter;
-    typedef typename TimerTraits<T2>::StoredType T2Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg3Type T3;
-    typedef typename TimerTraits<T3>::ParameterType T3Parameter;
-    typedef typename TimerTraits<T3>::StoredType T3Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg4Type T4;
-    typedef typename TimerTraits<T4>::ParameterType T4Parameter;
-    typedef typename TimerTraits<T4>::StoredType T4Stored;
-
-    struct FnTimerImplFour
-        : public TimerImplFour<T1Parameter, T2Parameter, T3Parameter, T4Parameter>
-    {
-        FnTimerImplFour(FN fn)
-            : m_fn(fn)
-        {
-        }
-
-        void SetArguments(T1Parameter a1, T2Parameter a2, T3Parameter a3, T4Parameter a4) override
-        {
-            m_a1 = a1;
-            m_a2 = a2;
-            m_a3 = a3;
-            m_a4 = a4;
-        }
-
-        EventId Schedule(const Time& delay) override
-        {
-            return Simulator::Schedule(delay, m_fn, m_a1, m_a2, m_a3, m_a4);
-        }
-
-        void Invoke() override
-        {
-            m_fn(m_a1, m_a2, m_a3, m_a4);
-        }
-
-        FN m_fn;
-        T1Stored m_a1;
-        T2Stored m_a2;
-        T3Stored m_a3;
-        T4Stored m_a4;
-    }* function = new FnTimerImplFour(fn);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking five arguments.
- * \copydetails MakeTimerImpl(FN)
- */
-template <typename FN>
-TimerImpl*
-MakeTimerImpl(IntToType<5>, FN fn)
-{
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg2Type T2;
-    typedef typename TimerTraits<T2>::ParameterType T2Parameter;
-    typedef typename TimerTraits<T2>::StoredType T2Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg3Type T3;
-    typedef typename TimerTraits<T3>::ParameterType T3Parameter;
-    typedef typename TimerTraits<T3>::StoredType T3Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg4Type T4;
-    typedef typename TimerTraits<T4>::ParameterType T4Parameter;
-    typedef typename TimerTraits<T4>::StoredType T4Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg5Type T5;
-    typedef typename TimerTraits<T5>::ParameterType T5Parameter;
-    typedef typename TimerTraits<T5>::StoredType T5Stored;
-
-    struct FnTimerImplFive
-        : public TimerImplFive<T1Parameter, T2Parameter, T3Parameter, T4Parameter, T5Parameter>
-    {
-        FnTimerImplFive(FN fn)
-            : m_fn(fn)
-        {
-        }
-
-        void SetArguments(T1Parameter a1,
-                          T2Parameter a2,
-                          T3Parameter a3,
-                          T4Parameter a4,
-                          T5Parameter a5) override
-        {
-            m_a1 = a1;
-            m_a2 = a2;
-            m_a3 = a3;
-            m_a4 = a4;
-            m_a5 = a5;
-        }
-
-        EventId Schedule(const Time& delay) override
-        {
-            return Simulator::Schedule(delay, m_fn, m_a1, m_a2, m_a3, m_a4, m_a5);
-        }
-
-        void Invoke() override
-        {
-            m_fn(m_a1, m_a2, m_a3, m_a4, m_a5);
-        }
-
-        FN m_fn;
-        T1Stored m_a1;
-        T2Stored m_a2;
-        T3Stored m_a3;
-        T4Stored m_a4;
-        T5Stored m_a5;
-    }* function = new FnTimerImplFive(fn);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking six arguments.
- * \copydetails MakeTimerImpl(FN)
- */
-template <typename FN>
-TimerImpl*
-MakeTimerImpl(IntToType<6>, FN fn)
-{
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg2Type T2;
-    typedef typename TimerTraits<T2>::ParameterType T2Parameter;
-    typedef typename TimerTraits<T2>::StoredType T2Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg3Type T3;
-    typedef typename TimerTraits<T3>::ParameterType T3Parameter;
-    typedef typename TimerTraits<T3>::StoredType T3Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg4Type T4;
-    typedef typename TimerTraits<T4>::ParameterType T4Parameter;
-    typedef typename TimerTraits<T4>::StoredType T4Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg5Type T5;
-    typedef typename TimerTraits<T5>::ParameterType T5Parameter;
-    typedef typename TimerTraits<T5>::StoredType T5Stored;
-    typedef typename TypeTraits<FN>::FunctionPointerTraits::Arg6Type T6;
-    typedef typename TimerTraits<T6>::ParameterType T6Parameter;
-    typedef typename TimerTraits<T6>::StoredType T6Stored;
-
-    struct FnTimerImplSix : public TimerImplSix<T1Parameter,
-                                                T2Parameter,
-                                                T3Parameter,
-                                                T4Parameter,
-                                                T5Parameter,
-                                                T6Parameter>
-    {
-        FnTimerImplSix(FN fn)
-            : m_fn(fn)
-        {
-        }
-
-        virtual void SetArguments(T1Parameter a1,
-                                  T2Parameter a2,
-                                  T3Parameter a3,
-                                  T4Parameter a4,
-                                  T5Parameter a5,
-                                  T6Parameter a6)
-        {
-            m_a1 = a1;
-            m_a2 = a2;
-            m_a3 = a3;
-            m_a4 = a4;
-            m_a5 = a5;
-            m_a6 = a6;
-        }
-
-        virtual EventId Schedule(const Time& delay)
-        {
-            return Simulator::Schedule(delay, m_fn, m_a1, m_a2, m_a3, m_a4, m_a5, m_a6);
-        }
-
-        virtual void Invoke()
-        {
-            m_fn(m_a1, m_a2, m_a3, m_a4, m_a5, m_a6);
+            std::apply([this](Ts... args) { (m_fn)(args...); }, m_arguments);
         }
 
-        FN m_fn;
-        T1Stored m_a1;
-        T2Stored m_a2;
-        T3Stored m_a3;
-        T4Stored m_a4;
-        T5Stored m_a5;
-        T6Stored m_a6;
-    }* function = new FnTimerImplSix(fn);
+        decltype(fn) m_fn;
+        std::tuple<std::remove_cvref_t<Ts>...> m_arguments;
+    }* function = new FnTimerImpl(fn);
 
     return function;
 }
 
 /**
- * Helper for the MakeTimerImpl functions which take a class method.
- *
- * This helper converts a pointer to a reference.
- *
- * This is the generic template declaration (with empty body).
- *
- * \tparam T \explicit The object type.
- */
-template <typename T>
-struct TimerImplMemberTraits;
-
-/**
- * Helper for the MakeTimerImpl functions which take a class method.
- *
- * This helper converts a pointer to a reference.
- *
- * This is the specialization for pointer to \c T.
- *
- * \tparam T \explicit The object type.
- */
-template <typename T>
-struct TimerImplMemberTraits<T*>
-{
-    /**
-     * Convert a pointer type to a reference.
-     *
-     * \param [in] p The pointer.
-     * \returns A reference to the object pointed to by \c p.
-     */
-    static T& GetReference(T* p)
-    {
-        return *p;
-    }
-};
-
-/**
  * Make a TimerImpl from a class method pointer taking
  * a varying number of arguments.
  *
- * \tparam MEM_PTR \deduced Class method function signature type.
  * \tparam OBJ_PTR \deduced Class type.
+ * \tparam U \deduced Class method function return type.
+ * \tparam V \deduced Class method function class type.
+ * \tparam Ts \deduced Class method function argument types.
  * \param [in] memPtr Class method to invoke when the timer expires.
  * \param [in] objPtr Object instance pointer.
  * \returns The TimerImpl.
  */
-template <typename MEM_PTR, typename OBJ_PTR>
-TimerImpl*
-MakeTimerImpl(MEM_PTR memPtr, OBJ_PTR objPtr)
-{
-    NS_ASSERT(TypeTraits<MEM_PTR>::IsPointerToMember);
-    return MakeTimerImpl(IntToType<TypeTraits<MEM_PTR>::PointerToMemberTraits::nArgs>(),
-                         memPtr,
-                         objPtr);
-}
-
-/**
- * Make a TimerImpl from a function pointer taking zero arguments.
- * \copydetails MakeTimerImpl(MEM_PTR,OBJ_PTR)
- */
-template <typename MEM_PTR, typename OBJ_PTR>
+template <typename OBJ_PTR, typename U, typename V, typename... Ts>
 TimerImpl*
-MakeTimerImpl(IntToType<0>, MEM_PTR memPtr, OBJ_PTR objPtr)
+MakeTimerImpl(U (V::*memPtr)(Ts...), OBJ_PTR objPtr)
 {
-    struct MemFnTimerImplZero : public TimerImpl
+    struct MemFnTimerImpl : public TimerImplX<const std::remove_cvref_t<Ts>&...>
     {
-        MemFnTimerImplZero(MEM_PTR memPtr, OBJ_PTR objPtr)
-            : m_memPtr(memPtr),
-              m_objPtr(objPtr)
+        MemFnTimerImpl(decltype(memPtr) memPtr, OBJ_PTR objPtr)
+            : m_memPtr(std::bind_front(memPtr, objPtr))
         {
         }
 
-        EventId Schedule(const Time& delay) override
+        void SetArguments(const std::remove_cvref_t<Ts>&... args) override
         {
-            return Simulator::Schedule(delay, m_memPtr, m_objPtr);
-        }
-
-        void Invoke() override
-        {
-            (TimerImplMemberTraits<OBJ_PTR>::GetReference(m_objPtr).*m_memPtr)();
-        }
-
-        MEM_PTR m_memPtr;
-        OBJ_PTR m_objPtr;
-    }* function = new MemFnTimerImplZero(memPtr, objPtr);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking one argument.
- * \copydetails MakeTimerImpl(MEM_PTR,OBJ_PTR)
- */
-template <typename MEM_PTR, typename OBJ_PTR>
-TimerImpl*
-MakeTimerImpl(IntToType<1>, MEM_PTR memPtr, OBJ_PTR objPtr)
-{
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-
-    struct MemFnTimerImplOne : public TimerImplOne<T1Parameter>
-    {
-        MemFnTimerImplOne(MEM_PTR memPtr, OBJ_PTR objPtr)
-            : m_memPtr(memPtr),
-              m_objPtr(objPtr)
-        {
-        }
-
-        void SetArguments(T1Parameter a1) override
-        {
-            m_a1 = a1;
+            m_arguments = std::tuple(args...);
         }
 
         EventId Schedule(const Time& delay) override
         {
-            return Simulator::Schedule(delay, m_memPtr, m_objPtr, m_a1);
+            return std::apply(
+                [&, this](Ts... args) {
+                    return Simulator::Schedule(delay, std::bind(m_memPtr, args...));
+                },
+                m_arguments);
         }
 
         void Invoke() override
         {
-            (TimerImplMemberTraits<OBJ_PTR>::GetReference(m_objPtr).*m_memPtr)(m_a1);
+            std::apply(m_memPtr, m_arguments);
         }
 
-        MEM_PTR m_memPtr;
-        OBJ_PTR m_objPtr;
-        T1Stored m_a1;
-    }* function = new MemFnTimerImplOne(memPtr, objPtr);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking two arguments.
- * \copydetails MakeTimerImpl(MEM_PTR,OBJ_PTR)
- */
-template <typename MEM_PTR, typename OBJ_PTR>
-TimerImpl*
-MakeTimerImpl(IntToType<2>, MEM_PTR memPtr, OBJ_PTR objPtr)
-{
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg2Type T2;
-    typedef typename TimerTraits<T2>::ParameterType T2Parameter;
-    typedef typename TimerTraits<T2>::StoredType T2Stored;
-
-    struct MemFnTimerImplTwo : public TimerImplTwo<T1Parameter, T2Parameter>
-    {
-        MemFnTimerImplTwo(MEM_PTR memPtr, OBJ_PTR objPtr)
-            : m_memPtr(memPtr),
-              m_objPtr(objPtr)
-        {
-        }
-
-        void SetArguments(T1Parameter a1, T2Parameter a2) override
-        {
-            m_a1 = a1;
-            m_a2 = a2;
-        }
-
-        EventId Schedule(const Time& delay) override
-        {
-            return Simulator::Schedule(delay, m_memPtr, m_objPtr, m_a1, m_a2);
-        }
-
-        void Invoke() override
-        {
-            (TimerImplMemberTraits<OBJ_PTR>::GetReference(m_objPtr).*m_memPtr)(m_a1, m_a2);
-        }
-
-        MEM_PTR m_memPtr;
-        OBJ_PTR m_objPtr;
-        T1Stored m_a1;
-        T2Stored m_a2;
-    }* function = new MemFnTimerImplTwo(memPtr, objPtr);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking three arguments.
- * \copydetails MakeTimerImpl(MEM_PTR,OBJ_PTR)
- */
-template <typename MEM_PTR, typename OBJ_PTR>
-TimerImpl*
-MakeTimerImpl(IntToType<3>, MEM_PTR memPtr, OBJ_PTR objPtr)
-{
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg2Type T2;
-    typedef typename TimerTraits<T2>::ParameterType T2Parameter;
-    typedef typename TimerTraits<T2>::StoredType T2Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg3Type T3;
-    typedef typename TimerTraits<T3>::ParameterType T3Parameter;
-    typedef typename TimerTraits<T3>::StoredType T3Stored;
-
-    struct MemFnTimerImplThree : public TimerImplThree<T1Parameter, T2Parameter, T3Parameter>
-    {
-        MemFnTimerImplThree(MEM_PTR memPtr, OBJ_PTR objPtr)
-            : m_memPtr(memPtr),
-              m_objPtr(objPtr)
-        {
-        }
-
-        void SetArguments(T1Parameter a1, T2Parameter a2, T3Parameter a3) override
-        {
-            m_a1 = a1;
-            m_a2 = a2;
-            m_a3 = a3;
-        }
-
-        EventId Schedule(const Time& delay) override
-        {
-            return Simulator::Schedule(delay, m_memPtr, m_objPtr, m_a1, m_a2, m_a3);
-        }
-
-        void Invoke() override
-        {
-            (TimerImplMemberTraits<OBJ_PTR>::GetReference(m_objPtr).*m_memPtr)(m_a1, m_a2, m_a3);
-        }
-
-        MEM_PTR m_memPtr;
-        OBJ_PTR m_objPtr;
-        T1Stored m_a1;
-        T2Stored m_a2;
-        T3Stored m_a3;
-    }* function = new MemFnTimerImplThree(memPtr, objPtr);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking four arguments.
- * \copydetails MakeTimerImpl(MEM_PTR,OBJ_PTR)
- */
-template <typename MEM_PTR, typename OBJ_PTR>
-TimerImpl*
-MakeTimerImpl(IntToType<4>, MEM_PTR memPtr, OBJ_PTR objPtr)
-{
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg2Type T2;
-    typedef typename TimerTraits<T2>::ParameterType T2Parameter;
-    typedef typename TimerTraits<T2>::StoredType T2Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg3Type T3;
-    typedef typename TimerTraits<T3>::ParameterType T3Parameter;
-    typedef typename TimerTraits<T3>::StoredType T3Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg4Type T4;
-    typedef typename TimerTraits<T4>::ParameterType T4Parameter;
-    typedef typename TimerTraits<T4>::StoredType T4Stored;
-
-    struct MemFnTimerImplFour
-        : public TimerImplFour<T1Parameter, T2Parameter, T3Parameter, T4Parameter>
-    {
-        MemFnTimerImplFour(MEM_PTR memPtr, OBJ_PTR objPtr)
-            : m_memPtr(memPtr),
-              m_objPtr(objPtr)
-        {
-        }
-
-        void SetArguments(T1Parameter a1, T2Parameter a2, T3Parameter a3, T4Parameter a4) override
-        {
-            m_a1 = a1;
-            m_a2 = a2;
-            m_a3 = a3;
-            m_a4 = a4;
-        }
-
-        EventId Schedule(const Time& delay) override
-        {
-            return Simulator::Schedule(delay, m_memPtr, m_objPtr, m_a1, m_a2, m_a3, m_a4);
-        }
-
-        void Invoke() override
-        {
-            (TimerImplMemberTraits<OBJ_PTR>::GetReference(m_objPtr).*
-             m_memPtr)(m_a1, m_a2, m_a3, m_a4);
-        }
-
-        MEM_PTR m_memPtr;
-        OBJ_PTR m_objPtr;
-        T1Stored m_a1;
-        T2Stored m_a2;
-        T3Stored m_a3;
-        T4Stored m_a4;
-    }* function = new MemFnTimerImplFour(memPtr, objPtr);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking five arguments.
- * \copydetails MakeTimerImpl(MEM_PTR,OBJ_PTR)
- */
-template <typename MEM_PTR, typename OBJ_PTR>
-TimerImpl*
-MakeTimerImpl(IntToType<5>, MEM_PTR memPtr, OBJ_PTR objPtr)
-{
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg2Type T2;
-    typedef typename TimerTraits<T2>::ParameterType T2Parameter;
-    typedef typename TimerTraits<T2>::StoredType T2Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg3Type T3;
-    typedef typename TimerTraits<T3>::ParameterType T3Parameter;
-    typedef typename TimerTraits<T3>::StoredType T3Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg4Type T4;
-    typedef typename TimerTraits<T4>::ParameterType T4Parameter;
-    typedef typename TimerTraits<T4>::StoredType T4Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg5Type T5;
-    typedef typename TimerTraits<T5>::ParameterType T5Parameter;
-    typedef typename TimerTraits<T5>::StoredType T5Stored;
-
-    struct MemFnTimerImplFive
-        : public TimerImplFive<T1Parameter, T2Parameter, T3Parameter, T4Parameter, T5Parameter>
-    {
-        MemFnTimerImplFive(MEM_PTR memPtr, OBJ_PTR objPtr)
-            : m_memPtr(memPtr),
-              m_objPtr(objPtr)
-        {
-        }
-
-        void SetArguments(T1Parameter a1,
-                          T2Parameter a2,
-                          T3Parameter a3,
-                          T4Parameter a4,
-                          T5Parameter a5) override
-        {
-            m_a1 = a1;
-            m_a2 = a2;
-            m_a3 = a3;
-            m_a4 = a4;
-            m_a5 = a5;
-        }
-
-        EventId Schedule(const Time& delay) override
-        {
-            return Simulator::Schedule(delay, m_memPtr, m_objPtr, m_a1, m_a2, m_a3, m_a4, m_a5);
-        }
-
-        void Invoke() override
-        {
-            (TimerImplMemberTraits<OBJ_PTR>::GetReference(m_objPtr).*
-             m_memPtr)(m_a1, m_a2, m_a3, m_a4, m_a5);
-        }
-
-        MEM_PTR m_memPtr;
-        OBJ_PTR m_objPtr;
-        T1Stored m_a1;
-        T2Stored m_a2;
-        T3Stored m_a3;
-        T4Stored m_a4;
-        T5Stored m_a5;
-    }* function = new MemFnTimerImplFive(memPtr, objPtr);
-
-    return function;
-}
-
-/**
- * Make a TimerImpl from a function pointer taking six arguments.
- * \copydetails MakeTimerImpl(MEM_PTR,OBJ_PTR)
- */
-template <typename MEM_PTR, typename OBJ_PTR>
-TimerImpl*
-MakeTimerImpl(IntToType<6>, MEM_PTR memPtr, OBJ_PTR objPtr)
-{
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg1Type T1;
-    typedef typename TimerTraits<T1>::ParameterType T1Parameter;
-    typedef typename TimerTraits<T1>::StoredType T1Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg2Type T2;
-    typedef typename TimerTraits<T2>::ParameterType T2Parameter;
-    typedef typename TimerTraits<T2>::StoredType T2Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg3Type T3;
-    typedef typename TimerTraits<T3>::ParameterType T3Parameter;
-    typedef typename TimerTraits<T3>::StoredType T3Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg4Type T4;
-    typedef typename TimerTraits<T4>::ParameterType T4Parameter;
-    typedef typename TimerTraits<T4>::StoredType T4Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg5Type T5;
-    typedef typename TimerTraits<T5>::ParameterType T5Parameter;
-    typedef typename TimerTraits<T5>::StoredType T5Stored;
-    typedef typename TypeTraits<MEM_PTR>::PointerToMemberTraits::Arg6Type T6;
-    typedef typename TimerTraits<T6>::ParameterType T6Parameter;
-    typedef typename TimerTraits<T6>::StoredType T6Stored;
-
-    struct MemFnTimerImplSix : public TimerImplSix<T1Parameter,
-                                                   T2Parameter,
-                                                   T3Parameter,
-                                                   T4Parameter,
-                                                   T5Parameter,
-                                                   T6Parameter>
-    {
-        MemFnTimerImplSix(MEM_PTR memPtr, OBJ_PTR objPtr)
-            : m_memPtr(memPtr),
-              m_objPtr(objPtr)
-        {
-        }
-
-        virtual void SetArguments(T1Parameter a1,
-                                  T2Parameter a2,
-                                  T3Parameter a3,
-                                  T4Parameter a4,
-                                  T5Parameter a5,
-                                  T6Parameter a6)
-        {
-            m_a1 = a1;
-            m_a2 = a2;
-            m_a3 = a3;
-            m_a4 = a4;
-            m_a5 = a5;
-            m_a6 = a6;
-        }
-
-        virtual EventId Schedule(const Time& delay)
-        {
-            return Simulator::Schedule(delay,
-                                       m_memPtr,
-                                       m_objPtr,
-                                       m_a1,
-                                       m_a2,
-                                       m_a3,
-                                       m_a4,
-                                       m_a5,
-                                       m_a6);
-        }
-
-        virtual void Invoke()
-        {
-            (TimerImplMemberTraits<OBJ_PTR>::GetReference(m_objPtr).*
-             m_memPtr)(m_a1, m_a2, m_a3, m_a4, m_a5, m_a6);
-        }
-
-        MEM_PTR m_memPtr;
-        OBJ_PTR m_objPtr;
-        T1Stored m_a1;
-        T2Stored m_a2;
-        T3Stored m_a3;
-        T4Stored m_a4;
-        T5Stored m_a5;
-        T6Stored m_a6;
-    }* function = new MemFnTimerImplSix(memPtr, objPtr);
+        std::function<U(Ts...)> m_memPtr;
+        std::tuple<std::remove_cvref_t<Ts>...> m_arguments;
+    }* function = new MemFnTimerImpl(memPtr, objPtr);
 
     return function;
 }
